package com.eactive.eai.batch.job.jobItem.ksdps;

import java.io.File;
import java.io.FileInputStream;

import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.common.exception.ExceptionUtil;


public class SEND_KSDPS_DATA extends DefaultTelegram implements TelegramService
{
    private String filename;
    private File f;
    private FileInputStream fin = null;
    private long fileSize = 0;

    public SEND_KSDPS_DATA() {
    }


    /**
     * 지정된 전문의 구성 필드 배열 선언, 요구송신 파일 Start DB로그
     */
    public boolean doPreExecute() {
		if (!super.doPreExecute()) return false;
		return true;
	}

    public boolean doExecute() {
        return true;
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
//            int nSumFormalField = 0;
//            for (int i=0; i<this.al_FieldLength.length ; i++) {
//                String strFieldLength = this.al_FieldLength[i];
//                if (!strFieldLength.equalsIgnoreCase(FIELD_NO_LENGTH)) {
//                    try {
//                        int nFldCnt = Integer.parseInt(strFieldLength);
//                        nSumFormalField = nSumFormalField + nFldCnt;
//                    } catch(Exception ex) {
//                        logger.error( ex.getMessage(), ex);
//                        byte[] aField = (byte[])this.al_Field.get(i);
//                        nSumFormalField = nSumFormalField + aField.length;
//                    }
//                }
//            }

            // 전체 전문의 길이를 여기에서...
            String fileDir = batchDoc.getBatchMsg().getHeader().getFilePath();
            String fileNm  = batchDoc.getBatchMsg().getHeader().getRenamedFileName();

            this.filename = fileDir+ File.separator + fileNm;
            this.f = new File(this.filename);
            if (!f.exists()) // 파일이 없으면 리턴 False
            {
            	logger.debug("{}  the File does not exist!!! ["+this.filename+"]", logHeader);
                String[] msgArgs = new String[1];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                String errCode = "BECEAIJI022";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            this.fileSize = f.length();
            int nLength = (int)f.length() ;//+ nSumFormalField;
            String recvBytes = batchDoc.getBatchMsg().getBody().getSendSummary();
            long l_recvBytes = 0;
            try {
            	l_recvBytes = Long.parseLong(recvBytes);
			} catch (Exception e) {
				return 0;
			}
            fin = new FileInputStream(f);
            if ( l_recvBytes > 0){
            	l_recvBytes = Math.min(l_recvBytes, this.fileSize);
            	fin.skip(l_recvBytes);
            	batchDoc.getBatchMsg().getBody().setCurFileSize(l_recvBytes);
            }

            return nLength - (int)l_recvBytes;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    /**
     * 비정형 필드에 대한 송수신 길이를 계산해서 리턴해준다.
     * 필드(idx)가 비정형 필드(XX)인지 점검하고 , 해당 필드에 대한 예상 길이를 계산하여 리턴하도록 한다
     * 비정형 필드를 가지고 있는 개별 Telegram Class 에서 오버라이드 필요.
     */
    public int getCalculatedLength(int idx)
    {
    	if ( idx == 0 ) return 0;

    	try {
            //  여기서는 전송대상인 파일의 크기를 리턴해준다.
    		logger.info("{} batch transefet job : Target file size = ["+this.fileSize+"]", logHeader);

            batchDoc.getBatchMsg().getHeader().setFileSize(this.fileSize);

            String recvBytes = batchDoc.getBatchMsg().getBody().getSendSummary();
            long l_recvBytes = 0;
            try {
            	l_recvBytes = Long.parseLong(recvBytes);
			} catch (Exception e) {
				return 0;
			}
            if ( l_recvBytes > 0){
            	l_recvBytes = Math.min(l_recvBytes, this.fileSize);
            }


            return (int)this.fileSize - (int)l_recvBytes;
         } catch(Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIJI005";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
         }
    }

    /**
     * 여기서는 파일을 닫는다.
     */
    public boolean doPostExecute() {
        try {
            if (!super.doPostExecute()) return false;

			//DB로그에 남길 파일 헤더,트레일러 내용 설정
			super.setFileHeaderAndTrailer(f);

//			//DB로그에 남길 전문 헤더 설정
//            ByteArrayOutputStream baout = new ByteArrayOutputStream();
//            for (int i=0; i<this.al_Field.size(); i++) {
//                baout.write((byte[])this.al_Field.get(i));
//            }
//            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

			if ( fin != null ){
	            fin.close();
			}
			logger.info("{}  doPostExecute called : file close", logHeader);
            return true;

        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    /**
     * OffSet은 FileInputStream 에 의해 자동관리 된다.
     */
    public int getInformalFieldSendData(int idx, byte[] data) {
        try {
            int rc = fin.read(data, 0, data.length);
            
            long lnCurSize = batchDoc.getBatchMsg().getBody().getCurFileSize() + rc;
            batchDoc.getBatchMsg().getBody().setCurFileSize(lnCurSize);  //파일사이즈 설정 (전송 진행상태 확인용)
            return rc;
            
        } catch (Exception ex) {
        	logger.error("{} ★★★★★ 송신 파일 데이터 READ 시 오류 발생 !! ★★★★★", logHeader, ex);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(ex.toString());
            return -1;
        }
    }

//    //---------------- 특정 필드값을 구하는 부분
//    // 전문종별코드 필드값 리턴
//    public String getTelegramType()
//    {
//		return super.getFieldValueString(8);
//    }
//    // 거래구분코드 필드값 리턴
//    public String getTrClass()
//    {
//		return super.getFieldValueString(9);
//    }
//    //응답코드 필드값 리턴
//    public String getResCode()
//    {
//		return "000";
//    }

}
